<?xml version="1.0" encoding="utf-8" ?>
<DUMMY>
  <!-- Includes **********************************************************-->
  <INCLUDE_ONCE file="tpl_lib.inc"/>
  <INCLUDE_ONCE file="knob/knob.inc"/>
  <INCLUDE_ONCE file="fader/fader.inc"/>
  <INCLUDE_ONCE file="colors.inc" />
  <INCLUDE_ONCE file="utils/tooltip.inc" />
  <INCLUDE_ONCE file="utils/utils.inc" />
  <INCLUDE_ONCE file="utils/tpl.text_button.inc"/>
  <INCLUDE_ONCE file="menu_button/menu_button.inc"/>
  <INCLUDE_ONCE file="logo_stick/logo_stick.inc"/>
  <INCLUDE_ONCE file="vmeter/vmeter.inc"/>
  <INCLUDE_ONCE file="h_slider/h_slider.inc"/>
  <INCLUDE_ONCE file="radio_button/radio_button.inc"/>
  <INCLUDE_ONCE file="link_button/link_button.inc"/>
  <INCLUDE_ONCE file="push_toggle/push_toggle.inc"/>
  <INCLUDE_ONCE file="black_box/black_box.inc"/>
  <INCLUDE_ONCE file="greybox/box.inc"/>
  <INCLUDE_ONCE file="DarkBlue-Theme/theme.inc" />
  <INCLUDE_ONCE file="language_extensions/language_extensions.inc"/>

  <!-- Definitions,variables and templates **********************************-->
  <DEFINE>
    <GRAYOUT_LAYER base_type="IMAGE" mouse_sensitive="true" repeat="true" image="gray_out.bmp" opacity="70%"/>
    <CATEGORY_TEXT base_type="TEXT" font_size="15" text_color="#777777"/>
    <CUS_V_RULER base_type="RULER" font_size="11" text_v_align="center"	v_margin="7" height="100%" width="15" value_format="+.0" content="{value}" positions_count="11" orientation="vertical" enable_positions_zoom="true" positions_zoom_base_factor="2"/>
    <CUS_H_RULER base_type="RULER" text_h_align="center" h_align="right" font_size="11" h_margin="15" height="13" value_format=".1" content="{value}" positions_count="11" significant_digits="2" value_suffix="true" drop_trailing_zeros="true"/>
    <CUS_GRID base_type="GRID" x_subdiv_count="1" y_subdiv_count="1" width="100%" height="100%"
    subdiv_color="#333333" color="#555555" origin_color="#888888" x_positions_count="11" y_positions_count="11" y_enable_positions_zoom="true" y_positions_zoom_base_factor="2"/>
    <CUS_GRAPH_SLIDER base_type="IMAGE_PARAM_SLIDER" thumb_image="vbar.png" thumb_image_mouse_mask="" width="100%" scale="log" cursor="system::size_h" orientation="horizontal" auto_focus="false"/>
    <CUS_CURVE_GRAPH base_type="CURVE_GRAPH" x_scale="log" width="100%" height="100%" sample_rate=".2"/>
    <CUS_FILLED_GRAPH base_type="CUS_CURVE_GRAPH" x_scale="log" width="100%" height="100%" sample_rate="1" graph_style="bargraph" anti_alias="false"/>
    <CUS_FADER_RULER base_type="RULER" positions_count="11" text_v_align="center" v_margin="6" width="15" orientation="vertical" content="{value}" value_format="+.0" text_color="#777777" font_size="11" enable_positions_zoom="true" positions_zoom_base_factor="2"/>
    <CUS_TEXT_BUTTON base_type="TPL_TEXT_BUTTON" button="CUS_ON_OFF_BUTTON" />
    <CUS_GREY_BOX base_type="CUS_DARK_BOX"/>
  </DEFINE>

  <!-- Variables -->
  <VARIABLE id="max_inter_bands_count" formula="$max_bands_count$-1"/>
  <VARIABLE id="spacing" value="3"/>
  <VARIABLE id="min_track_width" value="120"/>
  <IF_DUAL>
    <VARIABLE id="min_track_width" value="120" override="true"/>
  </IF_DUAL>

    <!-- Additionnal visibility data -->
    <PARAM id="spectrum_type" type="enumeration" persistent="true" default="0" enum_values="Spectrum;Grey Spectrogram;Color Spectrogram"/>
    <FOR_EACH_CHANNEL>
        <FORMULA_PARAM id="show_spectrum$channel_index$" formula="spectrum_ch$channel_index$_visible*(spectrum_type==0)"/>
    </FOR_EACH_CHANNEL>
    <FORMULA_PARAM id="show_spectrogram" formula="$analysis_enabled$*(spectrum_type>=1)"/>
    <FORMULA_PARAM id="show_greyscale_spectrogram" formula="$analysis_enabled$*(spectrum_type==1)"/>
    <FORMULA_PARAM id="show_color_spectrogram" formula="$analysis_enabled$*(spectrum_type==2)"/>
    <PARAM id="freeze" type="boolean" default="0"/>
    <PARAM_MULTI_LINK from="freeze" to="$spectrum_ch1$.paused;spectrogram_graph_color.paused;spectrogram_graph.paused"/>
    <IF_MONO>
        <VARIABLE id="spectrum_curve" value="$spectrum_ch1$"/>
        <FORMULA_PARAM id="spectrum_ch1_visible" formula="$analysis_enabled$"/>
    </IF_MONO>
    <IF_STEREO_OR_DUAL>
        <IF_STEREO>
            <PARAM id="spectrum_channel_select" type="enumeration" enum_values="Left;Both;Right" persistent="true" default="1"/>
        </IF_STEREO>
        <IF_DUAL>
            <PARAM id="spectrum_channel_select" type="enumeration" enum_values="Ch 1;Both;Ch 2" persistent="true" default="1"/>
        </IF_DUAL>
        <FORMULA_PARAM id="spectrum_ch1_visible" formula="spectrum_channel_select&lt;=1"/>
        <FORMULA_PARAM id="spectrum_ch2_visible" formula="spectrum_channel_select&gt;=1"/>
        <FORMULA_CURVE id="spectrum" formula="log(spectrum_ch1_visible*exp($spectrum_ch1$(x))+spectrum_ch2_visible*exp($spectrum_ch2$(x)))" x_min="20" x_max="22000" y_min="-120" y_max="0" y_default="-120"/>
        <VARIABLE id="spectrum_curve" value="spectrum"/>
        <PARAM_MULTI_LINK from="freeze" to="$spectrum_ch2$.paused"/>
    </IF_STEREO_OR_DUAL>
    
  <FOR_EACH_BAND>
    <REPEAT count="4" index_name="slot" start="1">
      <LOCAL_VARIABLE id="prop_index" formula="$slot$-1+($index$-1)*4"/>
      <ACTION id="plugin_menu$index$_$slot$" type="load_plugin_action"
              plugin_property_id="dsp.input_property$prop_index$" display_prefix="B$index$-S$slot$ - "
              plugin_name_string_id="plugin_name$index$_$slot$"
              plugin_custom_name_string_id="plugin_custom_name$index$_$slot$"
              plugin_error_param_id="plugin_error$index$_$slot$"
              plugin_bypass_param_id="plugin_bypass$index$_$slot$"
              plugin_show_editor_param_id="plugin_show_editor$index$_$slot$"
              plugin_editor_h_position_param_id="plugin_editor_h_position$index$_$slot$"
              plugin_editor_v_position_param_id="plugin_editor_v_position$index$_$slot$"
              plugin_loaded_param_id="plugin_loaded$index$_$slot$"
              vst_path_string_id="global.vst_plugins_path_$_PROCESSOR_ARCHITECTURE_$"
              track_plugin_undo_param_id="track_plugin$index$_$slot$_undo"
              generic_editor_skin_path="$_DIR_$/$THEME_NAME$_plugin_editor.inc"/>
      
      <STRING id="plugin_name$index$_$slot$" />
      <STRING id="plugin_custom_name$index$_$slot$" persistent="true" name="B$index$-S$slot$ -  Name"/>
      <PARAM id="track_plugin$index$_$slot$_undo" type="boolean" default="1" persistent="true"/>
      <PARAM id="plugin_bypass$index$_$slot$" type="boolean" default="0" persistent="true"/>
      <PARAM id="plugin_error$index$_$slot$" type="boolean" default="0"/>
      <PARAM id="plugin_loaded$index$_$slot$" type="boolean" default="0"/>

      <PARAM id="plugin_editor_h_position$index$_$slot$" type="integer" min="-9999999" max="9999999" default="9999999"/>
      <PARAM id="plugin_editor_v_position$index$_$slot$" type="integer" min="-9999999" max="9999999" default="9999999"/>
      <PARAM id="plugin_show_editor$index$_$slot$" type="boolean" default="0"/>
        
      <PARAM id="saved_plugin_show_editor$index$_$slot$" type="boolean" default="0" persistent="true"/>
      <PARAM id="saved_plugin_editor_h_position$index$_$slot$" type="integer" min="-9999999" max="9999999" default="9999999" persistent="true"/>
      <PARAM id="saved_plugin_editor_v_position$index$_$slot$" type="integer" min="-9999999" max="9999999" default="9999999" persistent="true"/>
      <PARAM_CONNECTION id="show_editor$index$_$slot$_link" id1="saved_plugin_show_editor$index$_$slot$" id2="plugin_show_editor$index$_$slot$" enabled="false"/>
      <PARAM_CONNECTION id="editor_h_position$index$_$slot$_link" id1="saved_plugin_editor_h_position$index$_$slot$" id2="plugin_editor_h_position$index$_$slot$" enabled="false"/>
      <PARAM_CONNECTION id="editor_v_position$index$_$slot$_link" id1="saved_plugin_editor_v_position$index$_$slot$" id2="plugin_editor_v_position$index$_$slot$" enabled="false"/>
      <PARAM_MULTI_LINK from="global.restore_plugin_editors" to="show_editor$index$_$slot$_link.enabled;editor_h_position$index$_$slot$_link.enabled;editor_v_position$index$_$slot$_link.enabled"/>
    </REPEAT>
  </FOR_EACH_BAND>

    <!-- Display strings -->
    <IF_NOT_DUAL>
        <FOR_EACH_BAND>
            <PARAM id="stick_text_$index$" type="enumeration" enum_values="B$index$" default="0"/>
        </FOR_EACH_BAND>
    </IF_NOT_DUAL>
    <IF_DUAL>
        <FOR_EACH_BAND>
            <PARAM id="stick_text_$index$_ch1" type="enumeration" enum_values="L$index$;M$index$" default="0"/>
            <PARAM id="stick_text_$index$_ch2" type="enumeration" enum_values="R$index$;S$index$" default="0"/>
            <PARAM_MULTI_LINK from="$stereo_mode$" to="stick_text_$index$_ch1;stick_text_$index$_ch2"/>
        </FOR_EACH_BAND>
    </IF_DUAL>
    
  <!-- Knob + parameter information -->
  <TEMPLATE id="TPL_KNOB_MODULE" param_id="#UNDEFINED" dsp_param_id="#UNDEFINED" display_name="" positions_count="201" response_curve="linear" reverse="false" knob_type="CUS_SYM_KNOB" v_align="center">
    <COLUMN spacing="0" text_color="#999999" v_align="$v_align$">
      <TEXT value="$display_name$"/>
      <DEFINE>
        <LOCAL_KNOB base_type="$knob_type$"/>
      </DEFINE>
      <COLUMN>
        <LOCAL_KNOB param_id="$param_id$" response_curve="$response_curve$" positions_count="$positions_count$" reverse="$reverse$"/>
        <CELL height="-7"/>
        <THEME_DSP_PARAM_SMALL_ROUND_SETTINGS_BUTTON param_id="$dsp_param_id$" v_align="bottom"/>
        <CELL height="-3"/>
      </COLUMN>
      <PARAM_TEXT_CONTROL param_id="$param_id$" width="50" text_color="#aaaaaa" content="{value}{unit}" value_format="+.1" pixels_range="0"/>
      <UNDEFINE>
        <LOCAL_KNOB/>
      </UNDEFINE>
    </COLUMN>
  </TEMPLATE>

  <!-- Level meter -->
  <TEMPLATE id="TPL_CHANNEL_METER" param_id="#UNDEFINED#" hold_param_id="#UNDEFINED#" >
    <ROW spacing="1" flex="1">
      <ROW  v_margin="6" height="100%">
        <GRID y_subdiv_count="1" height="100%" subdiv_color="#333333" origin_color="#777777" color="#777777" y_positions_count="11" y_param_info_id="$param_id$1$.info" width="3" />
        <FOR_EACH_CHANNEL>
          <LAYER_STACK height="100%">
            <CUS_VMETER param_id="$param_id$$channel_index$$" height="100%"/>
            <CUS_VMETER_HOLD param_id="$hold_param_id$$channel_index$$" height="100%"/>
          </LAYER_STACK>
        </FOR_EACH_CHANNEL>
        <GRID y_subdiv_count="1" height="100%" subdiv_color="#333333" origin_color="#777777" color="#777777" y_positions_count="11" y_param_info_id="$param_id$1$.info" width="3"/>
      </ROW>
      <RULER id="$param_id$_meter.ruler" param_info_id="$param_id$1$.info" positions_count="11" height="100%" text_v_align="center" v_margin="6" width="15" orientation="vertical" content="{value}" value_format=".0" text_color="#777777" font_size="11"/>
      <PARAM_LINK from="$param_id$_meter.ruler.height" to="$param_id$_meter.ruler.positions_count" formula="(x&lt;120)*6+(x&gt;=120)*11"/>
    </ROW>
  </TEMPLATE>

  <!-- Max Level meter -->
  <TEMPLATE id="TPL_MAX_PEAK_METER" max_param_id="#UNDEFINED#" max_reset_param_id="#UNDEFINED#">
    <LAYER_STACK>
      <PARAM_TEXT param_id="$max_param_id$" width="33" content="{text_value}" id="$id$.max_value"/>
      <PARAM_TEXT param_id="$max_param_id$" width="33" content="{text_value}" text_color="$red_color$" id="$id$.max_value_red"/>
      <PARAM_MULTI_LINK from="$max_param_id$;value0" mux_function=">" to="$id$.max_value_red.visible"/>
      <PARAM_LINK from="$id$.max_value_red.visible" to="$id$.max_value.visible" reverse="true"/>
      <INVISIBLE_PARAM_BUTTON param_id="$max_reset_param_id$" width="100%" height="100%" cursor="system::hand"/>
    </LAYER_STACK>
  </TEMPLATE>

  <!-- visibility and animation params -->
  <PARAM id="show_pre_plugins_slots" type="boolean" default="1" persistent="true"/>
  <PARAM id="show_post_plugins_slots" type="boolean" default="0" persistent="true"/>
  <FOR_EACH_BAND>
    <PARAM_LINK from="show_pre_plugins_slots" to="pre_plugins_slots$index$.display"/>
    <PARAM_LINK from="show_post_plugins_slots" to="post_plugins_slots$index$.display"/>
  </FOR_EACH_BAND>

  <TPL_SHOW_HIDE_ANIMATOR id="show_preferences_pane" object_id="preferences_pane" animated_param="v_offset" show_value="0" hide_value="-500" default="0"/>
  <TPL_SHOW_HIDE_ANIMATOR id="show_graph" object_id="graph_box" animated_param="h_offset" show_value="0" hide_value="-800" default="1" persistent="true" duration_ms="350"/>
  <TPL_SHOW_HIDE_ANIMATOR id="show_controls" object_id="controls_box" animated_param="h_offset" show_value="0" hide_value="-800" default="1" persistent="true" duration_ms="350"/>

  <!-- ***********************Standard Widths/ Heights*********************** -->
  <INCLUDE_ONCE file="screen_size.inc"/>
  <CONST_PARAM id="small_width" value="$small_screen_width$"/>
  <CONST_PARAM id="medium_width" value="$medium_screen_width$"/>
  <CONST_PARAM id="large_width" value="$large_screen_width$"/>
  <CONST_PARAM id="small_height" value="$small_screen_height$"/>
  <CONST_PARAM id="medium_height" value="$medium_screen_height$"/>
  <CONST_PARAM id="large_height" value="$large_screen_height$"/>
  <CONST_PARAM id="small_fader_height" value="$small_fader_height$"/>
  <CONST_PARAM id="medium_fader_height" value="$medium_fader_height$"/>
  <CONST_PARAM id="large_fader_height" value="$large_fader_height$"/>

  <PARAM_LINK from="small_width" to="selected_width" id="small_link" enabled="true"/>
  <PARAM_LINK from="small_height" to="selected_height" id="small_hlink" enabled="true"/>
  <PARAM_LINK from="small_fader_height" to="fader_height" id="small_fader_link" enabled="true"/>
  <PARAM_LINK from="medium_width" to="selected_width" id="medium_link" enabled="false"/>
  <PARAM_LINK from="medium_height" to="selected_height" id="medium_hlink" enabled="false"/>
  <PARAM_LINK from="medium_fader_height" to="fader_height" id="medium_fader_link" enabled="false"/>
  <PARAM_LINK from="large_width" to="selected_width" id="large_link" enabled="false"/>
  <PARAM_LINK from="large_height" to="selected_height" id="large_hlink" enabled="false"/>
  <PARAM_LINK from="large_fader_height" to="fader_height" id="large_fader_link" enabled="false"/>

  <PARAM_MULTI_LINK from="small_link.enabled" to="small_hlink.enabled;small_fader_link.enabled"/>
  <PARAM_MULTI_LINK from="large_link.enabled" to="large_hlink.enabled;large_fader_link.enabled"/>
  <PARAM_MULTI_LINK from="medium_link.enabled" to="medium_hlink.enabled;medium_fader_link.enabled"/>
  <PARAM_MULTI_LINK from="medium_link.enabled;large_link.enabled;small_link.enabled" to="medium_link.enabled;large_link.enabled;small_link.enabled" mux_function="max" reverse="true" trigger_min="1"/>

  <PERSISTENT_OBJECTS object_ids="small_link.enabled;medium_link.enabled;large_link.enabled"/>

  <!-- Layout starts here *****************************************************-->
  <THEME_DECORATIONS minimum_width="300" spacing="$spacing$" h_margin="10" preset_box_width="150">
    <THEME_TITLE_BAR text="BC MB-7 Mixer">
      <CELL width="8"/>
      <!-- Screen sizes -->
      <CELL width="8"/>
      <IMAGE_PARAM_BUTTON image="small_window.png" image_focus="small_window_hover.png" param_id="small_link.enabled" loop="false" cursor="system::hand">
        <TOOLTIP text="Small Size"/>
      </IMAGE_PARAM_BUTTON>
      <IMAGE_PARAM_BUTTON image="medium_window.png" image_focus="medium_window_hover.png" param_id="medium_link.enabled" loop="false" cursor="system::hand">
        <TOOLTIP text="Medium Size"/>
      </IMAGE_PARAM_BUTTON>
      <IMAGE_PARAM_BUTTON image="large_window.png" image_focus="large_window_hover.png" param_id="large_link.enabled" loop="false" cursor="system::hand">
        <TOOLTIP text="Large Size"/>
      </IMAGE_PARAM_BUTTON>
      <CELL width="8"/>
      <IMAGE_PARAM_BUTTON param_id="show_preferences_pane" image="prefs_button.png" image_focus="prefs_button_hover.png" reverse="false" cursor="system::hand">
        <TOOLTIP text="Show Preferences"/>
      </IMAGE_PARAM_BUTTON>
    </THEME_TITLE_BAR>

    <LAYER_STACK>
      <COLUMN spacing="$spacing$" id="main_cell">
        <CELL width="$small_screen_width$" v_margin="-$spacing$"/>
        <CELL id="min_width_cell" />
        <!-- Base controls-->
        <LAYER_STACK  width="100%" h_margin="10">
          <ROW spacing ="-2" h_align="left" >
          </ROW>
          <CUS_BLACK_BOX layout_type="row" spacing="4" v_margin="2" h_margin="5">
            <TEXT value="Range:"/>
            <PARAM_TEXT_TOGGLE_SWITCH text="12 dB" param_id="five_zoom_link.enabled"/>
            <CUS_BLACK_BOX_VSEPARATOR/>
            <PARAM_TEXT_TOGGLE_SWITCH text="24 dB" param_id="two_half_zoom_link.enabled"/>
            <CUS_BLACK_BOX_VSEPARATOR/>
            <PARAM_TEXT_TOGGLE_SWITCH text="60 dB" param_id="one_zoom_link.enabled"/>
          </CUS_BLACK_BOX>
          <IF_DUAL>
            <LAYER_STACK h_align="right">
              <THEME_STATUS_BUTTON_80 param_id="$stereo_mode$">
                <TEXT value="Mid/Side"/>
              </THEME_STATUS_BUTTON_80>
              <THEME_DSP_PARAM_SMALL_RECT_SETTINGS_BUTTON param_id="$stereo_mode$" v_align="bottom" v_offset="6"/>
            </LAYER_STACK>
          </IF_DUAL>
        </LAYER_STACK>

        <!-- Graph -->
        <THEME_GRAPH_BOX text_color="#777777" id="graph_box" h_margin="5">
          <ROW width="100%" flex="1">
            <!-- Other Y scale for spectrum-->
            <ROW height="100%" spacing="2">
              <CUS_V_RULER id="y_spectrum_scale" h_align="right" v_margin="8" width="25" param_info_id="$spectrum_ch1$.y_info" value_format=".0" content="{value}"
              positions_count="9"  offset=".5" />
              <PARAM_MULTI_LINK from="$analysis_enabled$" to="y_spectrum_scale.display;spectrum_scale_offset_cell.display"/>
              <PARAM_MULTI_LINK from="$analysis_enabled$" to="spectrum_scale_cell.display"/>
              <LAYER_STACK height="100%" v_margin="8" id="spectrum_scale_cell">
                <COLOR_SCALE id="spectrum_scale" height="100%" width="4" param_info_id="$spectrum_curve$.y_info" low_color="#000000" high_color="#ffffff" orientation="vertical" offset="1" response_curve="log"/>
                <PARAM_LINK from="show_greyscale_spectrogram" to="spectrum_scale.visible"/>
                <COLOR_SCALE id="spectrum_scale_color" height="100%" width="4" param_info_id="$spectrum_curve$.y_info" low_color="#000001" high_color="#ff0000" orientation="vertical" offset="1" response_curve="log"/>
                <PARAM_LINK from="show_color_spectrogram" to="spectrum_scale_color.visible"/>
              </LAYER_STACK>
            </ROW>
            <LAYER_STACK flex="1" height="100%">
              <!-- The Curves -->
              <LAYER_STACK v_margin="7" h_margin="4" width="100%" height="100%">
                <CURVE_OVER_TIME_COLOR_MAP id="spectrogram_graph" curve_id="$spectrum_curve$"  sample_rate="1" width="100%" height="100%" low_color="#000000" high_color="#eeeeee" orientation="vertical" y_scale="log" z_response_curve="log"/>
                <PARAM_LINK from="show_greyscale_spectrogram" to="spectrogram_graph.visible"/>
                <PARAM_LINK from="$analysis_enabled$" to="spectrogram_graph.paused" reverse="true"/>
                <CURVE_OVER_TIME_COLOR_MAP id="spectrogram_graph_color" curve_id="$spectrum_curve$"  sample_rate="1" width="100%" height="100%" low_color="#000001" high_color="#ff0000" orientation="vertical" y_scale="log" z_response_curve="log"/>
                <PARAM_LINK from="show_color_spectrogram" to="spectrogram_graph_color.visible"/>
                <PARAM_LINK from="$analysis_enabled$" to="spectrogram_graph_color.paused" reverse="true"/>

                <!-- Group all curves + grid in a single buffered window to optimize refreshing: these curves are not updated all the time -->
                <IMAGE_GROUP_BOX width="100%" height="100%" buffered="true" layout_type="layer_stack">
                  <CUS_GRID x_param_info_id="$global_response_ch1$.x_info" y_param_info_id="$global_response_ch1$.y_info" id="grid"/>
                  <!-- band curve(s) -->
                  <FOR_EACH_BAND index_name="i">
                    <CUS_FILLED_GRAPH curve_id="$frequency_response$i$$" color="$color$i$$" opacity="$graph_fill_opacity$" id="graph$i$" cursor="system::hand"/>
                  </FOR_EACH_BAND>
                  <FOR_EACH_BAND index_name="i">
                    <CUS_CURVE_GRAPH curve_id="$frequency_response$i$$" color="$color$i$$" id="graph$i$.1"/>
                  </FOR_EACH_BAND>
                  <!-- global response curve(s) -->
                  <FOR_EACH_CHANNEL>
                    <CUS_FILLED_GRAPH curve_id="$global_response_ch$channel_index$$" color="$response_fill_color_ch$channel_index$$" opacity="30%" id="global_graph_ch$channel_index$" sample_rate=".5"/>
                  </FOR_EACH_CHANNEL>
                  <FOR_EACH_CHANNEL>
                    <CUS_CURVE_GRAPH curve_id="$global_response_ch$channel_index$$" color="$response_color_ch$channel_index$$" id="global_response_graph_ch$channel_index$"/>
                  </FOR_EACH_CHANNEL>
                </IMAGE_GROUP_BOX>

                <!-- Spectrum (updated often, so it's separate)-->
                <FOR_EACH_CHANNEL>
                  <CUS_CURVE_GRAPH curve_id="$spectrum_ch$channel_index$$" color="$spectrum_color_ch$channel_index$$" sample_rate="1" id="spectrum_graph_ch$channel_index$"/>
                  <PARAM_LINK from="show_spectrum$channel_index$" to="spectrum_graph_ch$channel_index$.visible"/>
                </FOR_EACH_CHANNEL>

                <!-- The controller that let you see the xY coordinates values -->
                <XY_ZOOM_SELECT_PAD id="select_pad" height="100%" width="100%" x_zoom_param_id="graph_x_zoom_delayed" y_zoom_param_id="graph_y_zoom_delayed" x_offset_param_id="graph_x_offset_delayed" y_offset_param_id="graph_y_offset_delayed" cursor="system::cross" x_scale="log" visible="false"/>

                <!-- Freq Sliders -->
                <FOR_EACH_INTER_BAND>
                  <CUS_GRAPH_SLIDER param_id="$freq$index$$" id="crossover_bar$index$" height="100%"/>
                </FOR_EACH_INTER_BAND>

                <!-- Gain joysticks -->
                <FOR_EACH_BAND index_name="i">
                  <FOR_EACH_CONTROL_CHANNEL>
                    <IMAGE_GROUP_BOX buffered="true" id="joystick_box$i$$soft_ctrl_ch$" h_align="left" v_align="top" text_color="$color$i$$">
                      <THEME_BOX h_margin="6" v_margin="2" opacity="70%">
                        <PARAM_TEXT param_id="stick_text_$i$$soft_ctrl_ch$" font_size="14" width="18"/>
                      </THEME_BOX>
                    </IMAGE_GROUP_BOX>
                    <PARAM id="joystick_box$i$$soft_ctrl_ch$.display_offset" min="-1000" max="1000" default="0"/>
                    <FORMULA_PARAM id="joystick_box$i$$soft_ctrl_ch$_x" formula="stick$i$$soft_ctrl_ch$.x_value*grid.width-joystick_box$i$$soft_ctrl_ch$.width/2"/>
                    <FORMULA_PARAM id="joystick_box$i$$soft_ctrl_ch$_y" formula="(1-stick$i$$soft_ctrl_ch$.y_value)*grid.height-joystick_box$i$$soft_ctrl_ch$.height/2+joystick_box$i$$soft_ctrl_ch$.display_offset"/>
                    <PARAM_LINK from="joystick_box$i$$soft_ctrl_ch$_x" to="joystick_box$i$$soft_ctrl_ch$.h_offset"/>
                    <PARAM_LINK from="joystick_box$i$$soft_ctrl_ch$_y" to="joystick_box$i$$soft_ctrl_ch$.v_offset"/>
                    <PARAM_LINK from="stick$i$$soft_ctrl_ch$.visible" to="joystick_box$i$$soft_ctrl_ch$.visible"/>
                  </FOR_EACH_CONTROL_CHANNEL>
                </FOR_EACH_BAND>
              </LAYER_STACK>
              <FOR_EACH_BAND index_name="i">
                <FOR_EACH_CONTROL_CHANNEL>
                  <LOGO_STICK width="100%" y_param_id="model.gain$i$$soft_ctrl_ch$" x_param_id="band$i$_freq_pos$soft_ctrl_ch$" z_param_id="model.gain$i$$soft_ctrl_ch$" x_enabled="false" id="stick$i$$soft_ctrl_ch$" y_enable_positions_zoom="true" opacity="0" v_margin="7"/>
                </FOR_EACH_CONTROL_CHANNEL>
              </FOR_EACH_BAND>
            </LAYER_STACK>
            <!-- Y scale -->
            <LAYER_STACK height="100%">
              <CUS_V_RULER param_info_id="$global_response_ch1$.y_info" id="y_scale" />
              <XYZ_PARAM_SCRATCH_PAD height="100%" width="100%" y_param_id="graph_y_offset" y_reverse="true" id="graph_yruler_pad" cursor="system::open_hand"/>
            </LAYER_STACK>

            <ROW height="100%" h_margin="4">
              <!-- Gain Slider(s) -->
            <FOR_EACH_CONTROL_CHANNEL>                
              <PARAM_LINK from="gain_graph_control$soft_ctrl_ch$.enabled" to="gain_graph_slider$soft_ctrl_ch$.opacity" formula=".5*(1+x)"/>
              <THEME_GRAPH_BOX width="25" height="100%" layout_type="layer_stack" h_margin="1" v_margin="1" id="gain_graph_slider$soft_ctrl_ch$">
                <PARAM_TEXT id="gain_text$soft_ctrl_ch$" v_align="top" param_id="model.gain$soft_ctrl_ch$" content="{value} {unit}" value_format="+.1" width="14" height="53" text_h_align="right" font_escapement="90" font_size="14" text_color="#888888"/>
                <IMAGE_PARAM_SLIDER opacity="0" id="gain_graph_control$soft_ctrl_ch$" thumb_image="logo_stick/shinylogo.bmp" height="100%" param_id="model.gain$soft_ctrl_ch$" offset=".5" cursor="system::hand" positions_count="121" enable_positions_zoom="true"/>
                <THEME_BOX id="gain_thumb_box$soft_ctrl_ch$" h_align="left" v_align="top" width="100%" v_margin="2" opacity="70%">
                  <TEXT value="G." font_size="14" font_weight="bold" text_color="#cccccc"/>
                </THEME_BOX>
                <FORMULA_PARAM id="gain_thumb_box_y$soft_ctrl_ch$" formula="(1-gain_graph_control$soft_ctrl_ch$.value)*(gain_graph_control$soft_ctrl_ch$.height-gain_thumb_box$soft_ctrl_ch$.height)"/>
                <PARAM_LINK from="gain_thumb_box_y$soft_ctrl_ch$" to="gain_thumb_box$soft_ctrl_ch$.v_offset"/>
                <FORMULA_PARAM id="gain_text_y$soft_ctrl_ch$" formula="(gain_graph_control$soft_ctrl_ch$.value&gt;=.5)*(gain_thumb_box$soft_ctrl_ch$.v_offset+gain_thumb_box$soft_ctrl_ch$.height+15)+(gain_graph_control$soft_ctrl_ch$.value&lt;.5)*(gain_thumb_box$soft_ctrl_ch$.v_offset-gain_thumb_box$soft_ctrl_ch$.height-gain_text$soft_ctrl_ch$.height)"/>
                <PARAM_LINK from="gain_text_y$soft_ctrl_ch$" to="gain_text$soft_ctrl_ch$.v_offset"/>
                <PARAM_LINK from="gain_graph_control$soft_ctrl_ch$.pushed" to="gain_text$soft_ctrl_ch$.visible"/>
              </THEME_GRAPH_BOX>
             </FOR_EACH_CONTROL_CHANNEL>
            </ROW>
          </ROW>
          <!-- horizontal ruler at the bottom -->
          <ROW width="100%" h_margin="-5">
            <CELL width="25" id="spectrum_scale_offset_cell"/>
            <CUS_H_RULER param_info_id="$global_response_ch1$.x_info" id="x_scale" scale="log" flex="1">
              <XYZ_PARAM_SCRATCH_PAD height="100%" width="100%" x_param_id="graph_x_offset" x_reverse="true" id="graph_xruler_pad" cursor="system::open_hand"/>
            </CUS_H_RULER>
            <FOR_EACH_CONTROL_CHANNEL>
                <CELL width="30"/>
            </FOR_EACH_CONTROL_CHANNEL>
            <CELL width="10"/>
          </ROW>
          <!-- Additionnal graph controls: range and visibility -->
          <ROW spacing="10" v_margin="2">
            <ROW spacing="3">
              <CUS_CHECK_BOX param_id="response_graph_visible"/>
              <PARAM_TEXT_BUTTON param_id="response_graph_visible" text="Response"/>
            </ROW>
            <ROW spacing="3">
              <CUS_CHECK_BOX param_id="band_graphs_visible"/>
              <PARAM_TEXT_BUTTON param_id="band_graphs_visible" text="Bands"/>
            </ROW>
            <ROW spacing="3">
              <CUS_CHECK_BOX param_id="sticks_visible"/>
              <PARAM_TEXT_BUTTON param_id="sticks_visible" text="Controls"/>
            </ROW>
            <ROW spacing="5">
              <THEME_CHECK_BOX param_id="$analysis_enabled$"/>
              <TEXT value="Analysis">
                <INVISIBLE_PARAM_BUTTON param_id="$analysis_enabled$" width="100%" height="100%" cursor="system::hand"/>
              </TEXT>
              <TEXT value="-"/>
              <IF_STEREO_OR_DUAL>
                  <LAYER_STACK>
                      <ROW spacing="3">
                          <IMAGE image="arrow_down.png" v_offset="1"/>
                          <PARAM_TEXT param_id="spectrum_channel_select" width="30" text_h_align="left"/>
                      </ROW>
                      <INVISIBLE_PARAM_MENU_BUTTON param_id="spectrum_channel_select" width="100%" height="100%" cursor="system::hand"/>
                  </LAYER_STACK>
              </IF_STEREO_OR_DUAL>
              <LAYER_STACK>
                <ROW spacing="3">
                  <IMAGE image="arrow_down.png" v_offset="1"/>
                  <PARAM_TEXT param_id="spectrum_type" width="100" text_h_align="left"/>
                </ROW>
                <INVISIBLE_PARAM_MENU_BUTTON param_id="spectrum_type" width="100%" height="100%" cursor="system::hand"/>
              </LAYER_STACK>
            </ROW>
          </ROW>
        </THEME_GRAPH_BOX>
        <ROW width="100%" spacing="$spacing$" id="controls_box">
          <CELL width="60"/>
          <COLUMN flex="1"  spacing="$spacing$">
            <!-- Crossovers row -->
            <CELL width="100%" layout_type="layer_stack" h_margin="4" v_margin="2" id="crossovers_box" display="false">
              <CATEGORY_TEXT value="X-OVERS" opacity="50%" v_offset="5" id="x_over_text"/>
              <PARAM_LINK from="visible_bands_count" to="x_over_text.visible" formula="(x%2)!=0"/>
              <ROW width="100%">
                <COLUMN height="100%" v_margin="1"  text_color="#888888">
                  <CELL flex="1"/>
                  <TEXT value="Freq" text_h_align="left" h_align="left"/>
                  <CELL flex="1"/>
                  <CELL height="2"/>
                  <TEXT value="Slope" text_h_align="left" h_align="left"/>
                </COLUMN>
                <FOR_EACH_INTER_BAND>
                  <CELL flex="1" id="cross_flex$index$"/>
                  <IMAGE_GROUP_BOX layout_type="column" id="$index$_controls" spacing="1">
                    <LAYER_STACK>
                      <THEME_BOX width="80%" height="75%" h_align="right"/>
                      <ROW spacing="3">
                        <THEME_MINI_KNOB param_id="$freq$index$$" scale="log" pixel_range="300"/>
                        <PARAM_TEXT_CONTROL width="30" param_id="$freq$index$$" value_format=".0" content="{value}" flex="1" text_h_align="left" pixel_range="0"/>
                        <CELL width="2"/>
                      </ROW>
                      <THEME_DSP_PARAM_SMALL_RECT_SETTINGS_BUTTON param_id="$freq$index$$" v_align="bottom" h_offset="10" v_offset="3"/>
                    </LAYER_STACK>
                    <ROW>
                      <CELL width="4"/>
                      <ROW spacing="-2">
                        <CUS_PUSH_BUTTON  param_id="$slope$index$$" reverse="true" loop="false" positions_count="16">
                          <TEXT value="-"/>
                        </CUS_PUSH_BUTTON>
                        <IMAGE_PARAM_MENU_BUTTON param_id="$slope$index$$" cursor="system::hand" image="menu_button/button_small.bmp">
                          <ROW spacing="1">
                            <FORMULA_PARAM id="slope_value$index$" type="integer" formula="$slope$index$$*6" value_format=".0"/>
                            <PARAM_TEXT param_id="slope_value$index$" width="16"/>
                          </ROW>
                        </IMAGE_PARAM_MENU_BUTTON>
                        <CUS_PUSH_BUTTON  param_id="$slope$index$$" loop="false" positions_count="16">
                          <TEXT value="+"/>
                        </CUS_PUSH_BUTTON>
                      </ROW>
                    </ROW>
                  </IMAGE_GROUP_BOX>
                </FOR_EACH_INTER_BAND>
                <CELL flex="1"/>
                <COLUMN height="100%" v_margin="1"  text_color="#888888">
                  <CELL flex="1"/>
                  <TEXT value="Hz" text_h_align="left" h_align="left"/>
                  <CELL flex="1"/>
                  <CELL height="2"/>
                  <TEXT value="dB/oct" text_h_align="left" h_align="left"/>
                </COLUMN>
              </ROW>
            </CELL>

            <!-- Mixers channels -->
            <ROW width="100%" spacing="$spacing$">
              <FOR_EACH_BAND>
                <CUS_GREY_BOX layout_type="layer_stack" flex="1" id="band$index$_controls">
                  <COLUMN spacing="2" width="100%">
                    <!-- Header -->
                    <LAYER_STACK v_align="top" font_size="17" width="100%">
                      <COLUMN text_color="$color$index$$" spacing="-10" h_align="left">
                        <PARAM_TEXT_TOGGLE_SWITCH text=" $index$ " param_id="current_band$index$_link.enabled"/>
                        <TEXT value="-" id="monitor_select_$index$"/>
                        <PARAM_LINK from="band$index$_selected" to="monitor_select_$index$.visible"/>
                      </COLUMN>
                      <ROW v_align="top">
                        <CELL flex="1"/>
                        <ROW font_size="14" text_color="#cccccc" spacing="-2">
                          <LAYER_STACK>
                            <CUS_RADIO_BUTTON param_id="model.bypass$index$" text="B">
                              <CUS_TOOLTIP param_id="$bypass$index$$" content="{name}: {text_value}"/>
                            </CUS_RADIO_BUTTON>
                            <THEME_DSP_PARAM_MINI_SETTINGS_BUTTON param_id="$bypass$index$$" v_align="bottom" v_offset="6"/>
                          </LAYER_STACK>
                          <LAYER_STACK>
                            <CUS_RADIO_BUTTON param_id="model.mute$index$" text="M">
                              <CUS_TOOLTIP param_id="$mute$index$$" content="{name}: {text_value}"/>
                            </CUS_RADIO_BUTTON>
                            <THEME_DSP_PARAM_MINI_SETTINGS_BUTTON param_id="$mute$index$$" v_align="bottom" v_offset="6"/>
                          </LAYER_STACK>
                        </ROW>
                        <CELL flex="1"/>
                      </ROW>
                    </LAYER_STACK>
                    <!-- Plug-ins -->
                    <COLUMN spacing="2" width="100%" id="pre_plugins_slots$index$">
                      <REPEAT count="2" index_name="slot" start="1">
                        <CUS_BLACK_BOX width="100%" height="16" text_color="#888888" id="plugin_slot_box$index$_$slot$">
                          <INVISIBLE_ACTION_BUTTON action="plugin_menu$index$_$slot$" id="plugin_menu_button$index$_$slot$" image="menu_button/button.bmp" width="100%" height="100%" cursor="system::hand" layout_type="layer_stack">
                            <PARAM_MULTI_LINK from="plugin_error$index$_$slot$;plugin_bypass$index$_$slot$" to="plugin_name$index$_$slot$_field.visible" mux_function="max" reverse="true"/>
                            <PARAM_LINK from="plugin_error$index$_$slot$" to="plugin_name$index$_$slot$_error_field.visible"/>
                            <PARAM_LINK from="plugin_bypass$index$_$slot$" to="plugin_slot_box$index$_$slot$.opacity" formula="1-x*.3"/>
                            <FORMULA_PARAM id="show_bypass_field$index$_$slot$" formula="(plugin_bypass$index$_$slot$)&amp;&amp;(!plugin_error$index$_$slot$)"/>
                            <PARAM_LINK from="show_bypass_field$index$_$slot$" to="plugin_name$index$_$slot$_bypass_field.visible"/>
                            <ROW width="100%" height="100%" h_margin="1">
                                <IMAGE_PARAM_BUTTON image="power_icon.png" image_mask="" param_id="plugin_bypass$index$_$slot$" display="false" id="plugin_slot_bypass_button$index$_$slot$" orientation="vertical" cursor="system::hand" reverse="true"/>
                                <LAYER_STACK height="100%" flex="1">
                                <TEXT string_id="plugin_name$index$_$slot$" width="100%" height="100%" fit_text="abbreviate" id="plugin_name$index$_$slot$_field"/>
                                <TEXT string_id="plugin_name$index$_$slot$" width="100%" height="100%" fit_text="abbreviate" text_color="#777777" id="plugin_name$index$_$slot$_bypass_field"/>
                                <TEXT string_id="plugin_name$index$_$slot$" width="100%" height="100%" fit_text="truncate" text_color="#ee668e" id="plugin_name$index$_$slot$_error_field"/>
                                </LAYER_STACK>
                                 <IMAGE_PARAM_BUTTON image="window_icon.png" image_mask="" param_id="plugin_show_editor$index$_$slot$" display="false" id="plugin_slot_editor_button$index$_$slot$" orientation="vertical" cursor="system::hand"/>
                            </ROW>
                            <FORMULA_PARAM id="show_slot$index$_$slot$_buttons" formula="plugin_loaded$index$_$slot$&amp;&amp;(plugin_slot_editor_button$index$_$slot$.mouse_over||plugin_menu_button$index$_$slot$.mouse_over||plugin_slot_bypass_button$index$_$slot$.mouse_over)"/>
                            <PARAM_MULTI_LINK from="show_slot$index$_$slot$_buttons" to="plugin_slot_bypass_button$index$_$slot$.display;plugin_slot_editor_button$index$_$slot$.display"/>
                          </INVISIBLE_ACTION_BUTTON>
                        </CUS_BLACK_BOX>
                      </REPEAT>
                    </COLUMN>
                    <!-- Fader & meter -->
                    <LAYER_STACK width="100%">

                      <ROW width="100%">
                        <COLUMN height="100%" h_align="left">
                          <CELL flex="1"/>
                          <CUS_LINK_BUTTON param_id="model.band$index$_quick_group">
                            <CUS_TOOLTIP param_id="model.band$index$_quick_group" content="Quick Group: {text_value}"/>
                          </CUS_LINK_BUTTON>
                          <CELL font_size="14" text_color="#cccccc">
                            <CUS_RADIO_BUTTON param_id="model.band$index$_link_reverse" text="R" >
                              <CUS_TOOLTIP param_id="model.band$index$_link_reverse" content="Reverse Link: {text_value}"/>
                            </CUS_RADIO_BUTTON>
                          </CELL>
                        </COLUMN>
                        <CELL flex="1"/>
                        <ROW>
                          <COLUMN height="100%">
                            <CELL height="8"/>
                            <CUS_FADER_RULER param_info_id="model.gain$index$$ch1suffix$.info" flex="1" id="gain$index$_fader_ruler">
                              <XYZ_PARAM_SCRATCH_PAD height="100%" width="100%" y_param_id="graph_y_offset" y_reverse="true" id="gain$index$_fader_ruler_pad" cursor="system::open_hand"/>
                              <PARAM_LINK from="gain$index$_fader_ruler.height" to="gain$index$_fader_ruler.positions_count" formula="(x&lt;120)*6+(x&gt;=120)*11"/>
                            </CUS_FADER_RULER>
                            <CELL height="13"/>
                          </COLUMN>

                          <LAYER_STACK>
                            <IF_DUAL>
                              <ROW spacing="0" v_align="top" text_color="#dddddd">
                                <!-- Control connection between channels -->
                                <CUS_MINI_RADIO_BUTTON text="m" param_id="model.mute$index$_ch1">
                                  <TOOLTIP text="Mute Channel 1"/>
                                </CUS_MINI_RADIO_BUTTON>
                                <CUS_LINK_BUTTON param_id="model.channels$index$_link.enabled">
                                  <TOOLTIP text="Link Channels"/>
                                </CUS_LINK_BUTTON>
                                <CUS_MINI_RADIO_BUTTON text="m" param_id="model.mute$index$_ch2">
                                  <TOOLTIP text="Mute Channel 2"/>
                                </CUS_MINI_RADIO_BUTTON>
                              </ROW>
                            </IF_DUAL>
                            <ROW spacing="-3">
                              <FOR_EACH_CONTROL_CHANNEL>
                                <LAYER_STACK>
                                  <CUS_FADER param_id="model.gain$index$$soft_ctrl_ch$" positions_count="121" id="gain$index$_fader$soft_ctrl_ch$" enable_positions_zoom="true"/>
                                  <THEME_DSP_PARAM_MINI_SETTINGS_BUTTON param_id="$gain$index$$ctrl_ch$$" v_align="bottom"/>
                                </LAYER_STACK>
                              </FOR_EACH_CONTROL_CHANNEL>
                            </ROW>
                          </LAYER_STACK>
                        </ROW>
                        <CELL flex=".1"/>
                        <COLUMN height="100%">
                          <CELL height="8"/>
                          <TPL_CHANNEL_METER param_id="$peak_level$index$_ch" hold_param_id="$peak_hold_level$index$_ch" max_param_id="$max_peak_level$index$_ch" max_reset_param_id="$reset_max$index$$" id="level_meter$index$"/>
                          <ROW height="13" spacing="-4">
                            <FOR_EACH_CHANNEL>
                              <THEME_DSP_PARAM_MINI_SETTINGS_BUTTON param_id="$peak_level$index$_ch$channel_index$$" v_align="bottom"/>
                            </FOR_EACH_CHANNEL>
                          </ROW>
                        </COLUMN>
                        <CELL flex="1"/>
                      </ROW>
                    </LAYER_STACK>
                    <COLUMN spacing="3">
                      <LAYER_STACK>
                        <FOR_EACH_CONTROL_CHANNEL>
                          <IF_DUAL>
                            <PARAM_MULTI_LINK from="gain$index$_fader$soft_ctrl_ch$.mouse_over;gain$index$_fader$soft_ctrl_ch$.focus;stick$index$$soft_ctrl_ch$.focus" to="gain$index$$soft_ctrl_ch$_label.visible" mux_function="max"/>
                          </IF_DUAL>
                          <PARAM_TEXT_CONTROL id="gain$index$$soft_ctrl_ch$_label" param_id="model.gain$index$$soft_ctrl_ch$" width="50" pixel_range="0"/>
                        </FOR_EACH_CONTROL_CHANNEL>
                      </LAYER_STACK>
                      <IF_STEREO>
                        <ROW spacing="-12">
                          <TPL_KNOB_MODULE param_id="model.spread$index$" dsp_param_id="$spread$index$$" display_name="Spread" v_align="top"/>
                          <COLUMN>
                            <CELL height="12"/>
                            <TPL_KNOB_MODULE param_id="model.pan$index$" dsp_param_id="$pan$index$$" display_name="Pan" v_align="bottom"/>
                          </COLUMN>
                        </ROW>
                      </IF_STEREO>
                      <IF_DUAL>
                        <ROW spacing="-4">
                          <TPL_KNOB_MODULE param_id="model.pan$index$_ch1" dsp_param_id="$pan$index$_ch1$" display_name="Pan Ch1" v_align="top"/>
                          <COLUMN>
                            <CELL height="12"/>
                            <TPL_KNOB_MODULE param_id="model.pan$index$_ch2" dsp_param_id="$pan$index$_ch2$" display_name="Pan Ch2" v_align="bottom"/>
                          </COLUMN>
                        </ROW>
                      </IF_DUAL>
                      <TPL_MENU_BUTTON param_id="model.band$index$_link" content="{text_value}"/>
                    </COLUMN>
                    <COLUMN spacing="2" width="100%"  id="post_plugins_slots$index$">
                      <REPEAT count="2" index_name="slot" start="3" >
                          <CUS_BLACK_BOX width="100%" height="16" text_color="#888888" id="plugin_slot_box$index$_$slot$">
                              <INVISIBLE_ACTION_BUTTON action="plugin_menu$index$_$slot$" id="plugin_menu_button$index$_$slot$" image="menu_button/button.bmp" width="100%" height="100%" cursor="system::hand" layout_type="layer_stack">
                                  <PARAM_MULTI_LINK from="plugin_error$index$_$slot$;plugin_bypass$index$_$slot$" to="plugin_name$index$_$slot$_field.visible" mux_function="max" reverse="true"/>
                                  <PARAM_LINK from="plugin_error$index$_$slot$" to="plugin_name$index$_$slot$_error_field.visible"/>
                                  <PARAM_LINK from="plugin_bypass$index$_$slot$" to="plugin_slot_box$index$_$slot$.opacity" formula="1-x*.3"/>
                                  <FORMULA_PARAM id="show_bypass_field$index$_$slot$" formula="(plugin_bypass$index$_$slot$)&amp;&amp;(!plugin_error$index$_$slot$)"/>
                                  <PARAM_LINK from="show_bypass_field$index$_$slot$" to="plugin_name$index$_$slot$_bypass_field.visible"/>
                                  <ROW width="100%" height="100%" h_margin="1">
                                      <IMAGE_PARAM_BUTTON image="power_icon.png" image_mask="" param_id="plugin_bypass$index$_$slot$" display="false" id="plugin_slot_bypass_button$index$_$slot$" orientation="vertical" cursor="system::hand" reverse="true"/>
                                      <LAYER_STACK height="100%" flex="1">
                                          <TEXT string_id="plugin_name$index$_$slot$" width="100%" height="100%" fit_text="abbreviate" id="plugin_name$index$_$slot$_field"/>
                                          <TEXT string_id="plugin_name$index$_$slot$" width="100%" height="100%" fit_text="abbreviate" text_color="#777777" id="plugin_name$index$_$slot$_bypass_field"/>
                                          <TEXT string_id="plugin_name$index$_$slot$" width="100%" height="100%" fit_text="truncate" text_color="#ee668e" id="plugin_name$index$_$slot$_error_field"/>
                                      </LAYER_STACK>
                                      <IMAGE_PARAM_BUTTON image="window_icon.png" image_mask="" param_id="plugin_show_editor$index$_$slot$" display="false" id="plugin_slot_editor_button$index$_$slot$" orientation="vertical" cursor="system::hand"/>
                                  </ROW>
                                  <FORMULA_PARAM id="show_slot$index$_$slot$_buttons" formula="plugin_loaded$index$_$slot$&amp;&amp;(plugin_slot_editor_button$index$_$slot$.mouse_over||plugin_menu_button$index$_$slot$.mouse_over||plugin_slot_bypass_button$index$_$slot$.mouse_over)"/>
                                  <PARAM_MULTI_LINK from="show_slot$index$_$slot$_buttons" to="plugin_slot_bypass_button$index$_$slot$.display;plugin_slot_editor_button$index$_$slot$.display"/>
                              </INVISIBLE_ACTION_BUTTON>
                          </CUS_BLACK_BOX>
                      </REPEAT>
                    </COLUMN>
                  </COLUMN>
                  <GRAYOUT_LAYER width="100%" height="100%" id="grayed_monitor$index$" visible="false"/>
                </CUS_GREY_BOX>
              </FOR_EACH_BAND>
            </ROW>
          </COLUMN>
          <!-- Master box -->
          <THEME_BOX height="100%" layout_type="row" h_margin="5">
            <COLUMN height="100%" spacing="2">
              <CATEGORY_TEXT value="MASTER"/>
              <CELL height="4"/>
              <IF_STEREO>
                <COLUMN>
                  <CUS_LARGE_RADIO_BUTTON param_id="$mono$" text="Mono" reverse="true"/>
                  <THEME_DSP_PARAM_SMALL_RECT_SETTINGS_BUTTON param_id="$mono$"/>
                </COLUMN>
              </IF_STEREO>
              <!-- Max meters -->
              <ROW spacing="2">
                <FOR_EACH_CHANNEL>
                  <TPL_MAX_PEAK_METER max_param_id="$max_peak_level_ch$channel_index$$" max_reset_param_id="$reset_max$" id="main_level_meter_ch$channel_index$"/>
                  <IF condition="$channel_index$==1">
                    <TEXT value="dB"/>
                  </IF>
                </FOR_EACH_CHANNEL>
              </ROW>
              <!-- -->
              <ROW flex="1">
                <COLUMN spacing="2" v_align="top" font_size="15" height="100%">
                  <CELL flex="1"/>
                  <CUS_LINK_BUTTON param_id="model.master_quick_group">
                    <CUS_TOOLTIP param_id="model.master_quick_group" content="Quick Group: {text_value}"/>
                  </CUS_LINK_BUTTON>
                  <CELL font_size="14" text_color="#cccccc">
                    <CUS_RADIO_BUTTON param_id="model.master_link_reverse" text="R">
                      <CUS_TOOLTIP param_id="model.master_link_reverse" content="Reverse Link: {text_value}"/>
                    </CUS_RADIO_BUTTON>
                  </CELL>
                </COLUMN>
                <ROW height="100%">
                  <COLUMN height="100%">
                    <CELL height="8"/>
                    <CUS_FADER_RULER param_info_id="$gain_ch1$.info" flex="1" id="gain_fader_ruler">
                      <XYZ_PARAM_SCRATCH_PAD height="100%" width="100%" y_param_id="graph_y_offset" y_reverse="true" id="gain_fader_ruler_pad" cursor="system::open_hand"/>
                    </CUS_FADER_RULER>
                    <CELL height="13"/>
                  </COLUMN>
                  <LAYER_STACK height="100%">
                    <IF_DUAL>
                      <CELL v_align="top">
                        <!-- Control connection between channels -->
                        <CUS_LINK_BUTTON param_id="model.channels_link.enabled">
                          <TOOLTIP text="Link Channels"/>
                        </CUS_LINK_BUTTON>
                      </CELL>
                    </IF_DUAL>
                    <ROW spacing="-3" height="100%">
                      <FOR_EACH_CONTROL_CHANNEL>
                        <LAYER_STACK height="100%">
                          <CUS_FADER param_id="model.gain$soft_ctrl_ch$" positions_count="121" height="100%" id="gain_fader$soft_ctrl_ch$" enable_positions_zoom="true"/>
                          <THEME_DSP_PARAM_MINI_SETTINGS_BUTTON param_id="$gain$ctrl_ch$$" v_align="bottom"/>
                        </LAYER_STACK>
                      </FOR_EACH_CONTROL_CHANNEL>
                    </ROW>
                  </LAYER_STACK>
                </ROW>
                <CELL width="2"/>
                <COLUMN height="100%">
                  <CELL height="8"/>
                  <TPL_CHANNEL_METER param_id="$peak_level_ch" hold_param_id="$peak_hold_level_ch" />
                  <ROW height="13" spacing="-4">
                    <FOR_EACH_CHANNEL>
                      <THEME_DSP_PARAM_MINI_SETTINGS_BUTTON param_id="$peak_level_ch$channel_index$$" v_align="bottom"/>
                    </FOR_EACH_CHANNEL>
                  </ROW>
                </COLUMN>
                <CELL width="10"/>
              </ROW>
              <COLUMN spacing="3">
                <LAYER_STACK>
                  <FOR_EACH_CONTROL_CHANNEL>
                    <IF_DUAL>
                      <PARAM_MULTI_LINK from="gain_fader$soft_ctrl_ch$.mouse_over;gain_fader$soft_ctrl_ch$.focus;gain_graph_control$soft_ctrl_ch$.focus" to="gain$soft_ctrl_ch$_label.visible" mux_function="max"/>
                    </IF_DUAL>
                    <PARAM_TEXT_CONTROL id="gain$soft_ctrl_ch$_label" param_id="model.gain$soft_ctrl_ch$" width="50" pixel_range="0"/>
                  </FOR_EACH_CONTROL_CHANNEL>
                </LAYER_STACK>
                <IF_DUAL>
                  <ROW spacing="-8">
                    <TPL_KNOB_MODULE param_id="model.pan_ch1" dsp_param_id="$pan_ch1$" display_name="Pan Ch1" v_align="top"/>
                    <COLUMN>
                      <CELL height="12"/>
                      <TPL_KNOB_MODULE param_id="model.pan_ch2" dsp_param_id="$pan_ch2$" display_name="Pan Ch2" v_align="bottom"/>
                    </COLUMN>
                  </ROW>
                </IF_DUAL>
                <TPL_MENU_BUTTON param_id="model.master_link" content="{text_value}" positions_count="5"/>
              </COLUMN>
            </COLUMN>
          </THEME_BOX>
          <CELL width="60"/>
        </ROW>
      </COLUMN>
      <THEME_BOX id="preferences_pane" display="false" layout_type="column" font_size="+2" opacity="80%" mouse_sensitive="true">
        <TEXT value="PREFERENCES" font_size="+1"/>
        <THEME_BOX_H_SEPARATOR/>
        <TEXT value="VST plug-ins directory:" h_align="left" font_weight="bold"/>
        <ROW>
          <TEXT string_id="global.vst_plugins_path_$_PROCESSOR_ARCHITECTURE_$" width="300" text_h_align="left">
            <INVISIBLE_ACTION_BUTTON action_id="choose_vst_plugins_path" width="100%" height="100%" cursor="system::hand"/>
          </TEXT>
          <THEME_BOX v_margin="2">
            <TEXT value="...">
              <ACTION id="choose_vst_plugins_path" type="DisplayFolderSelectDialog" file_path_string_id="global.vst_plugins_path_$_PROCESSOR_ARCHITECTURE_$"/>
              <INVISIBLE_ACTION_BUTTON action_id="choose_vst_plugins_path" width="100%" height="100%" cursor="system::hand">
                <TOOLTIP text="Click to select a folder"/>
              </INVISIBLE_ACTION_BUTTON>
            </TEXT>
          </THEME_BOX>
        </ROW>
        <THEME_BOX_H_SEPARATOR/>
        <ROW spacing="8" h_align="left">
          <CUS_CHECK_BOX param_id="global.restore_plugin_editors"/>
          <TEXT value="Restore plug-ins editors on open" h_align="left">
            <INVISIBLE_PARAM_BUTTON width="100%" height="100%" param_id="global.restore_plugin_editors" cursor="system::hand"/>
          </TEXT>
        </ROW>
        <THEME_BOX h_align="right">
          <TEXT value="Close">
            <INVISIBLE_PARAM_BUTTON param_id="show_preferences_pane" width="100%" height="100%" cursor="system::hand"/>
          </TEXT>
        </THEME_BOX>
      </THEME_BOX>
    </LAYER_STACK>
  </THEME_DECORATIONS>

  <!-- ************************************* Data / Models ***********************************-->
  <!-- window width computation: selected width is the minimum width, increase if necessary, based on the number of bands-->
  <!-- Placed at the end of the skin so that all other params are updated before (for animations)-->
  <PARAM id="selected_width" default="600" min="0" max="4096"/>
  <PARAM id="selected_height" default="600" min="0" max="4096"/>
  <PARAM id="fader_height" default="200" min="0" max="4096"/>
  <FORMULA_PARAM id="min_window_width" formula="($bands_count$+1)*$min_track_width$"/>
  <FORMULA_PARAM id="window_width" formula="max(selected_width,min_window_width)"/>
  <FORMULA_PARAM id="max_track_width" formula="$min_track_width$+band1_controls.height*.1"/>

  <PARAM_LINK from="window_width" to="graph_box.width"/>
  <PARAM_LINK from="min_window_width" to="min_width_cell.width"/>
  <PARAM_LINK from="selected_height" to="graph_box.height"/>
  <VARIABLE id="visible_bands_formula" value="0"/>
  <FOR_EACH_BAND>
    <FOR_EACH_CONTROL_CHANNEL>
      <PARAM_LINK from="fader_height" to="gain$index$_fader$soft_ctrl_ch$.height"/>
    </FOR_EACH_CONTROL_CHANNEL>
    <VARIABLE id="visible_bands_formula" value="$visible_bands_formula$+band$index$_controls_display" override="true"/>
  </FOR_EACH_BAND>
  <FORMULA_PARAM id="visible_bands_count" formula="$visible_bands_formula$"/>

  <!-- The graph zooming params -->
  <REPEAT index_list="graph_x_zoom;graph_x_offset;graph_y_zoom;graph_y_offset">
    <TPL_PARAM_ANIMATOR id="$index$_delayed" param_id="$index$" persistent="true"/>
  </REPEAT>
  <PARAM id="graph_x_zoom" min="1" max="5" default="1" name="X zoom" persistent="false" />
  <PARAM id="graph_x_offset" min="0" max="1" default=".5" name="X offset" persistent="false" />
  <PARAM id="graph_y_zoom" min="1" max="6" default="1" name="Y zoom" persistent="false" />
  <PARAM id="graph_y_offset" min="0" max="1" default=".5" name="Y offset" persistent="false" />

  <!-- Zoom links -->
  <PARAM_MULTI_LINK from="grid.x_extra_pixels" to="graph_xruler_pad.x_pixel_range" />
  <PARAM_MULTI_LINK from="grid.y_extra_pixels" to="graph_yruler_pad.y_pixel_range" />

  <PARAM_MULTI_LINK from="graph_x_zoom" to="grid.x_zoom;select_pad.x_zoom;x_scale.zoom"/>
  <PARAM_MULTI_LINK from="graph_x_offset" to="grid.x_offset;select_pad.x_offset;x_scale.offset"/>
  <PARAM_MULTI_LINK from="graph_y_zoom" to="grid.y_zoom;select_pad.y_zoom;y_scale.zoom"/>
  <PARAM_MULTI_LINK from="graph_y_offset" to="grid.y_offset;select_pad.y_offset;y_scale.offset"/>

  <!-- Compute pixel range for fader, based on zoom and height-->
  <FORMULA_PARAM id="gain_fader_ruler_pad_pixel_range" formula="gain1_fader_ruler_pad.height*(graph_y_zoom-1)"/>
  <FOR_EACH_BAND>
    <PARAM_MULTI_LINK from="graph_x_zoom" to="graph$index$.x_zoom;graph$index$.1.x_zoom"/>
    <PARAM_MULTI_LINK from="graph_x_offset" to="graph$index$.x_offset;graph$index$.1.x_offset"/>
    <PARAM_MULTI_LINK from="graph_y_zoom" to="graph$index$.y_zoom;graph$index$.1.y_zoom"/>
    <PARAM_MULTI_LINK from="graph_y_offset" to="graph$index$.y_offset;graph$index$.1.y_offset"/>
    <PARAM_LINK from="graph_y_zoom" to="gain$index$_fader_ruler.zoom"/>
    <PARAM_LINK from="graph_y_offset" to="gain$index$_fader_ruler.offset"/>
    <FOR_EACH_CONTROL_CHANNEL>
      <PARAM_MULTI_LINK from="graph_y_zoom" to="gain$index$_fader$soft_ctrl_ch$.zoom;stick$index$$soft_ctrl_ch$.y_zoom"/>
      <PARAM_MULTI_LINK from="graph_y_offset" to="gain$index$_fader$soft_ctrl_ch$.offset;stick$index$$soft_ctrl_ch$.y_offset"/>
    </FOR_EACH_CONTROL_CHANNEL>
    <PARAM_LINK from="gain_fader_ruler_pad_pixel_range" to="gain$index$_fader_ruler_pad.y_pixel_range"/>
  </FOR_EACH_BAND>
  <PARAM_LINK from="gain_fader_ruler_pad_pixel_range" to="gain_fader_ruler_pad.y_pixel_range"/>
  <PARAM_LINK from="graph_y_zoom" to="gain_fader_ruler.zoom"/>
  <PARAM_LINK from="graph_y_offset" to="gain_fader_ruler.offset"/>
  <FOR_EACH_CONTROL_CHANNEL>
    <PARAM_MULTI_LINK from="graph_y_zoom" to="gain_graph_control$soft_ctrl_ch$.zoom;gain_fader$soft_ctrl_ch$.zoom"/>
    <PARAM_MULTI_LINK from="graph_y_offset" to="gain_graph_control$soft_ctrl_ch$.offset;gain_fader$soft_ctrl_ch$.offset"/>
  </FOR_EACH_CONTROL_CHANNEL>

  <FOR_EACH_INTER_BAND>
    <PARAM_LINK from="graph_x_zoom" to="crossover_bar$index$.zoom"/>
    <PARAM_LINK from="graph_x_offset" to="crossover_bar$index$.offset"/>
  </FOR_EACH_INTER_BAND>

  <FOR_EACH_CHANNEL>
    <PARAM_MULTI_LINK from="graph_x_zoom" to="spectrum_graph_ch$channel_index$.x_zoom;global_graph_ch$channel_index$.x_zoom;global_response_graph_ch$channel_index$.x_zoom"/>
    <PARAM_MULTI_LINK from="graph_y_zoom" to="global_graph_ch$channel_index$.y_zoom;global_response_graph_ch$channel_index$.y_zoom"/>
    <PARAM_MULTI_LINK from="graph_x_offset" to="spectrum_graph_ch$channel_index$.x_offset;global_graph_ch$channel_index$.x_offset;global_response_graph_ch$channel_index$.x_offset"/>
    <PARAM_MULTI_LINK from="graph_y_offset" to="global_graph_ch$channel_index$.y_offset;global_response_graph_ch$channel_index$.y_offset"/>
  </FOR_EACH_CHANNEL>

  <!-- zoom shortcuts links -->
  <PARAM_LINK from="value0" to="graph_y_zoom_delayed" enabled="false" id="one_zoom_link"/>
  <PARAM_LINK from="value2.5" to="graph_y_zoom_delayed" enabled="false" id="two_half_zoom_link"/>
  <PARAM_LINK from="value5" to="graph_y_zoom_delayed" enabled="false" id="five_zoom_link"/>

  <!-- link the crossover frequencies together with a min/max -->
  <REPEAT count="$max_inter_bands_count$-1" start="1">
    <LOCAL_VARIABLE id="next_index" formula="$index$+1"/>
    <PARAM_MIN_MAX_LINK min="$freq$index$$" max="$freq$next_index$$"/>
  </REPEAT>

  <!-- Manage the graphs, sliders visibility -->
  <PARAM id="band_graphs_visible" type="boolean" default="1" persistent="true"/>
  <PARAM id="response_graph_visible" type="boolean" default="1" persistent="true"/>
  <PARAM id="sticks_visible" type="boolean" default="1" persistent="true"/>
  <PARAM id="current_band" min="1" max="$max_bands_count$" default="1" type="integer"/>

  <FOR_EACH_CHANNEL>
    <PARAM_MULTI_LINK from="response_graph_visible" to="global_graph_ch$channel_index$.visible;global_response_graph_ch$channel_index$.visible"/>
  </FOR_EACH_CHANNEL>

  <FOR_EACH_BAND>
    <!-- main params that trigger visibility-->
    <FORMULA_PARAM id="band$index$_available" min="0" max="1" type="boolean" formula="$bands_count$>=$index$"/>
    <FORMULA_PARAM id="band$index$_selected" min="0" max="1" type="boolean" formula="current_band==$index$"/>

    <!-- Current band updater -->
    <PARAM_LINK from="value$index$" to="current_band" id="current_band$index$_link"/>
    <FOR_EACH_CONTROL_CHANNEL>
      <PARAM_MULTI_LINK from="stick$index$$soft_ctrl_ch$.focus;gain$index$_fader$soft_ctrl_ch$.focus" to="current_band$index$_link.enabled" mux_function="max"/>
    </FOR_EACH_CONTROL_CHANNEL>

    <!-- separate visibility for graph, filled graph and joystick -->
    <PARAM_MULTI_LINK from="band$index$_available;band_graphs_visible" to="graph$index$.1.visible"  mux_function="min"/>
    <PARAM_MULTI_LINK from="band$index$_available;band$index$_selected;band_graphs_visible" to="graph$index$.visible"  mux_function="min"/>
    <FOR_EACH_CONTROL_CHANNEL>
      <PARAM_MULTI_LINK from="band$index$_available;sticks_visible" to="stick$index$$soft_ctrl_ch$.visible" mux_function="min"/>
    </FOR_EACH_CONTROL_CHANNEL>
    <PARAM_LINK from="band$index$_available" to="show_grayed_monitor$index$" reverse="true"/>
    <TPL_SHOW_HIDE_ANIMATOR id="show_grayed_monitor$index$" object_id="grayed_monitor$index$" show_param="visible" animated_param="opacity" show_value=".6" hide_value="0"/>
    <FORMULA_PARAM id="band$index$_controls_display" formula="(band$index$_available)||(main_cell.width/($index$+1)&gt;max_track_width)"/>
    <PARAM_LINK from="band$index$_controls_display" to="show_band$index$_controls"/>
    <TPL_SHOW_HIDE_ANIMATOR id="show_band$index$_controls" object_id="band$index$_controls" animated_param="v_offset" show_value="0" hide_value="300"/>
  </FOR_EACH_BAND>

  <FOR_EACH_INTER_BAND>
    <LOCAL_VARIABLE id="next_index" formula="$index$+1"/>
    <!-- next band not displayed -> remove crossover-->
    <PARAM_MULTI_LINK from="band$next_index$_controls.display" to="$index$_controls.display;show_cross_flex$index$"/>
    <TPL_SHOW_HIDE_ANIMATOR id="show_cross_flex$index$" object_id="cross_flex$index$" animated_param="flex" show_value="1" hide_value="0"/>

    <!-- show only available crossovers -->
    <PARAM_MULTI_LINK from="band$next_index$_available" to="crossover_bar$index$.visible;$index$_controls.visible"/>
  </FOR_EACH_INTER_BAND>

  <!-- "virtual" positions of the crossover sliders depending on their visibility-->
  <CUS_CONST_PARAM id="bar0_pos" value="0"/>
  <FOR_EACH_INTER_BAND>
    <PARAM id="bar$index$_pos" min="0" max="1"/>
    <!-- Consider the value for the crossover bar as 1 if not visible (pushed on the right), else use the position of the slider-->
    <PARAM_LINK from="crossover_bar$index$.value" to="bar$index$_pos" id="bar$index$_link" enabled="true"/>
    <PARAM_LINK from="value1" to="bar$index$_pos" id="bar$index$_link_off" enabled="false"/>
    <PARAM_LINK from="crossover_bar$index$.visible" to="bar$index$_link.enabled"/>
    <PARAM_LINK from="crossover_bar$index$.visible" to="bar$index$_link_off.enabled" reverse="true"/>
  </FOR_EACH_INTER_BAND>
  <CUS_CONST_PARAM id="bar$max_bands_count$_pos" value="1"/>

  <!-- position of the band centers (joysticks): average-->
  <FOR_EACH_BAND>
    <!-- can't use formula because this param has to be R/W to be used by joystick -->
    <LOCAL_VARIABLE id="prev_index" formula="$index$-1"/>
    <LOCAL_VARIABLE id="current_offset" value="-1"/>
    <FOR_EACH_CONTROL_CHANNEL>
      <IF_DUAL>
          <FORMULA_PARAM id="offset_factor$index$$soft_ctrl_ch$" formula="$current_offset$*(stick$index$_ch1.visible)*(stick$index$_ch2.visible)*exp(-(120*((joystick_box$index$_ch1_y-joystick_box$index$_ch2_y)/grid.height)^2))*12/grid.width"/>
          <FORMULA_PARAM id="temp_band$index$_freq_pos$soft_ctrl_ch$" min="0" max="1" formula="(bar$index$_pos+bar$prev_index$_pos)*.5+offset_factor$index$$soft_ctrl_ch$"/>
      </IF_DUAL>
      <IF_NOT_DUAL>
        <FORMULA_PARAM id="temp_band$index$_freq_pos$soft_ctrl_ch$" min="0" max="1" formula="(bar$index$_pos+bar$prev_index$_pos)*.5"/>
      </IF_NOT_DUAL>

      <!-- can't use formula because this param has to be R/W to be used by joystick -->
      <PARAM id="band$index$_freq_pos$soft_ctrl_ch$" min="0" max="1"/>
      <PARAM_LINK from="temp_band$index$_freq_pos$soft_ctrl_ch$" to="band$index$_freq_pos$soft_ctrl_ch$"/>
        
      <VARIABLE id="current_offset" formula="$current_offset$+2" override="true"/>
    </FOR_EACH_CONTROL_CHANNEL>
  </FOR_EACH_BAND>

  <!-- Constants -->
  <REPEAT count="8">
    <CUS_CONST_PARAM value="$index$" id="value$index$"/>
  </REPEAT>
  <CUS_CONST_PARAM value="2.5" id="value2.5"/>
  
  <!-- Imposed values for single band skin-->
  <!-- Single band -->
  <PARAM_CONNECTION constraint="true" id1="$bands_count$" id2="value1"/>
  <PARAM_CONNECTION constraint="true" id1="model.solo1" id2="value1"/>

  <!-- No Spectrum Analysis nor graph-->
  <PARAM_CONNECTION constraint="true" id1="$analysis_enabled$" id2="value0"/>
  <PARAM_CONNECTION constraint="true" id1="show_graph" id2="value0"/>
  <PARAM_CONNECTION constraint="true" id1="show_controls" id2="value1"/>
  <PARAM_CONNECTION constraint="true" id1="show_pre_plugins_slots" id2="value1"/>
  <PARAM_CONNECTION constraint="true" id1="show_post_plugins_slots" id2="value1"/>

  <!-- Small Size -->
  <PARAM_CONNECTION constraint="true" id1="show_graph" id2="value0"/>
</DUMMY>