<?xml version="1.0" encoding="utf-8" ?>
<DUMMY>
    <!-- Generic Skin configuration-->
    <LOCAL_VARIABLE id="controls_per_row" value="8"/>

    <!-- Theme include -->
	<INCLUDE_ONCE file="$THEME_NAME$-Theme/theme.inc" />

    <!-- Dummy variables -->
    <PARAM id="current_preset.modified"/>
    <STRING id="current_preset.name" default="Default"/>
    
    <!-- Counting Rows and Choosing knob type -->
    <VARIABLE id="rows_count" formula="$PLUGIN_INPUT_PARAMS_COUNT$/$controls_per_row$+(($PLUGIN_INPUT_PARAMS_COUNT$%$controls_per_row$)!=0)"/>
    <REPEAT count="$rows_count$&lt;=4">
        <DEFINE>
            <CUS_SKIN_KNOB base_type="THEME_KNOB"/>
        </DEFINE>
    </REPEAT>
	<REPEAT count="$rows_count$&gt;4">
        <DEFINE>
            <CUS_SKIN_KNOB base_type="THEME_MINI_KNOB"/>
        </DEFINE>
    </REPEAT>
    
    
    <!--Layout starts here, inside theme decorations -->
	<THEME_DECORATIONS show_toolbar="false">
     <THEME_TITLE_BAR text="$PLUGIN_NAME$" show_settings="false" show_bypass="false"/>
     <COLUMN spacing="8">
         
         <!-- Parameters Knobs-->
         <REPEAT count="$rows_count$" index_name="row_index">
             <LOCAL_VARIABLE id="current_count" formula="min($controls_per_row$,$PLUGIN_INPUT_PARAMS_COUNT$-$row_index$*$controls_per_row$)"/>
             <LOCAL_VARIABLE id="current_start_index" formula="$row_index$*$controls_per_row$"/>
             <THEME_BOX spacing="0">
                 <REPEAT count="$current_count$" start="$current_start_index$">
                     <COLUMN v_align="top" spacing="4" width="90">
                         <PARAM_TEXT param_id="dsp.input$index$" content="{name}" font_weight="bold" font_size="+1" fit_text="abbreviate" width="100%"/>
                         <PARAM_TEXT param_id="dsp.input$index$"  width="100%" fit_text="abbreviate">
                             <!-- Select menu, visible only if number of positions is between 2 and 50 -->
                             <INVISIBLE_PARAM_MENU_BUTTON width="100%" height="100%"  param_id="dsp.input$index$" visible="false" id="input_control_menu$index$" cursor="system::hand"/>
                             <PARAM_LINK from="input_control_menu$index$.positions_count" to="input_control_menu$index$.visible" formula="(x>=2)and(x&lt;=50)"/>
                         </PARAM_TEXT>
                         <CUS_SKIN_KNOB param_id="dsp.input$index$"/>
                     </COLUMN>
                 </REPEAT>
             </THEME_BOX>
         </REPEAT>
         
         <!-- The "No Controls" text if there is no control to display -->
         <REPEAT count="$PLUGIN_INPUT_PARAMS_COUNT$==0">
             <THEME_BOX width="200" height="40">
                 <TEXT value="No Controls"/>
             </THEME_BOX>
         </REPEAT>
      </COLUMN>  
 </THEME_DECORATIONS>
</DUMMY>