<?xml version="1.0" encoding="utf-8" ?>
<DUMMY>
    <!-- General variables *****************************************************-->
    <VARIABLE id="channels_count" value="$PLUGIN_AUDIO_OUTPUTS_COUNT$"/>
    <VARIABLE id="max_bands_count" value="7"/>
    
    <!-- Basic definitions based on channels/bands count ***********************-->
    <DEFINE>
        <IF_MONO base_type="REPEAT" count="$channels_count$==1" index_name="_if_index_"/>
        <IF_STEREO base_type="REPEAT" count="($channels_count$==2)&amp;&amp;($PLUGIN_INPUT_PARAMS_COUNT$&lt;90)" index_name="_if_index_"/>
        <IF_DUAL base_type="REPEAT" count="($channels_count$==2)&amp;&amp;($PLUGIN_INPUT_PARAMS_COUNT$&gt;90)" index_name="_if_index_"/>
        <IF_STEREO_OR_DUAL base_type="REPEAT" count="$channels_count$==2" index_name="_if_index_"/>
        <IF_NOT_DUAL base_type="REPEAT" count="($channels_count$!=2)||($PLUGIN_INPUT_PARAMS_COUNT$&lt;90)" index_name="_if_index_"/>
        
        <FOR_EACH_CHANNEL base_type="REPEAT" count="$channels_count$" index_name="channel_index" start="1"/>
        <FOR_EACH_BAND base_type="REPEAT" count="$max_bands_count$" start="1"/>
        <FOR_EACH_INTER_BAND base_type="REPEAT" count="$max_inter_bands_count$" start="1"/>
    </DEFINE>
    
    <!-- Suffix for double channels controls in the dual version-->
    <TEMPLATE id="TPL_CONTROL_CHANNELS_LOOP">
        <REPEAT index_list="$index_list$" index_name="ctrl_ch">
            <LOCAL_VARIABLE id="soft_ctrl_ch" value=""/>
            <IF_DUAL>
                <VARIABLE id="soft_ctrl_ch" value="$ctrl_ch$" override="true"/>
            </IF_DUAL>
            <TEMPLATE_INNER_CONTENT/>
        </REPEAT>
    </TEMPLATE>
    <IF_DUAL>
        <VARIABLE id="ch1suffix" value="_ch1"/>
         <DEFINE>
             <FOR_EACH_CONTROL_CHANNEL base_type="TPL_CONTROL_CHANNELS_LOOP" index_list="_ch1;_ch2"/>
         </DEFINE>
     </IF_DUAL>
    <IF_NOT_DUAL>
        <VARIABLE id="ch1suffix" value=""/>
        <DEFINE>
            <FOR_EACH_CONTROL_CHANNEL base_type="TPL_CONTROL_CHANNELS_LOOP" index_list="_ch1"/>
        </DEFINE>
    </IF_NOT_DUAL>
    
    <!-- The mapping utilities that define the NEXT_ / CURRENT_ macros-->
    <INCLUDE_ONCE file="mapping_utils.inc"/>
    
    <!-- Input Parameters ******************************************************-->
    <NEXT_INPUT_PARAM id="bypass"/>
    <IF_DUAL>
        <NEXT_INPUT_PARAM id="stereo_mode"/>
    </IF_DUAL>
    <NEXT_INPUT_PARAM id="bands_count"/>
    
    <FOR_EACH_BAND>
        <!-- Band Parameters -->
        <NEXT_INPUT_PARAM id="bypass$index$"/>
        <NEXT_INPUT_PARAM id="mute$index$"/>
        <NEXT_INPUT_PARAM id="solo$index$"/>
        <NEXT_INPUT_PARAM id="gain$index$_ch1"/>
        <IF_DUAL>
            <NEXT_INPUT_PARAM id="gain$index$_ch2"/>
            <NEXT_INPUT_PARAM id="pan$index$_ch1"/>
            <NEXT_INPUT_PARAM id="pan$index$_ch2"/>
            <NEXT_INPUT_PARAM id="channel_mute$index$_ch1"/>
            <NEXT_INPUT_PARAM id="channel_mute$index$_ch2"/>
        </IF_DUAL>
        <IF_STEREO>
            <NEXT_INPUT_PARAM id="spread$index$"/>
            <NEXT_INPUT_PARAM id="pan$index$"/>
        </IF_STEREO>
        <NEXT_INPUT_PARAM id="reset_max$index$"/>
        
        <!-- slope and freq  between bands-->
        <REPEAT count="$index$!=$max_bands_count$">
            <NEXT_INPUT_PARAM id="freq$index$"/>
            <NEXT_INPUT_PARAM id="slope$index$"/>
        </REPEAT>
    </FOR_EACH_BAND>
    
    <!-- Global Output stage -->
    <NEXT_INPUT_PARAM id="gain_ch1"/>
    <IF_DUAL>
         <NEXT_INPUT_PARAM id="gain_ch2"/>
        <NEXT_INPUT_PARAM id="pan_ch1"/>
        <NEXT_INPUT_PARAM id="pan_ch2"/>
        <NEXT_INPUT_PARAM id="channel_mute_ch1"/>
        <NEXT_INPUT_PARAM id="channel_mute_ch2"/>
    </IF_DUAL>
    <IF_STEREO>
        <NEXT_INPUT_PARAM id="mono"/>
    </IF_STEREO>
    <NEXT_INPUT_PARAM id="reset_max"/>
    <NEXT_INPUT_PARAM id="analysis_enabled"/>
    
    <!-- Output params **********************************************************-->
    <!-- Band params -->
    <FOR_EACH_BAND>
        <FOR_EACH_CHANNEL>
            <NEXT_OUTPUT_PARAM id="peak_level$index$_ch$channel_index$"/>
            <NEXT_OUTPUT_PARAM id="peak_hold_level$index$_ch$channel_index$"/>
            <NEXT_OUTPUT_PARAM id="max_peak_level$index$_ch$channel_index$"/>
        </FOR_EACH_CHANNEL>
    </FOR_EACH_BAND>
    //<!-- Global (Master)-->
    <FOR_EACH_CHANNEL>
        <NEXT_OUTPUT_PARAM id="peak_level_ch$channel_index$"/>
        <NEXT_OUTPUT_PARAM id="peak_hold_level_ch$channel_index$"/>
        <NEXT_OUTPUT_PARAM id="max_peak_level_ch$channel_index$"/>
    </FOR_EACH_CHANNEL>
    
    <!-- Output Curves **********************************************************-->
    <!-- Global Response Output Curves -->
    <FOR_EACH_CHANNEL>
        <NEXT_OUTPUT_CURVE id="global_response_ch$channel_index$"/>
    </FOR_EACH_CHANNEL>
    
    <!-- Bands Output Curves -->
    <FOR_EACH_BAND>
        <NEXT_OUTPUT_CURVE id="frequency_response$index$"/>
    </FOR_EACH_BAND>
    
    <FOR_EACH_CHANNEL>
        <NEXT_OUTPUT_CURVE id="spectrum_ch$channel_index$"/>
    </FOR_EACH_CHANNEL>
    
    <!-- Extra params and variables *********************************************-->
    <!-- Opacity -->
    <PARAM id="global_opacity" min="0" max="100" default="100" unit="%" persistent="true"/>
    <PARAM_LINK from="global_opacity" to="window.opacity" normalized="true"/>
</DUMMY>